package cn.com.ctop.common.module.mapper;

import cn.com.ctop.common.module.entity.Advertiser;
import cn.com.ctop.common.module.entity.Product;
import cn.com.ctop.common.module.entity.Project;
import cn.com.ctop.common.module.vo.*;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


public interface ProductMapper extends BaseMapper<Product> {

    Long insertProduct(@Param("product") ProductVO product);

    List<Advertiser> getAdvertiserList();

    List<Project> getProjectListByAdvertiserId(@Param("advertiserId")String advertiserId);

    List<ProductDto> getYunyingListByProjectIds(@Param("projectIds")List<Long> projectIds);

    List<ProductDto> getSaleListByProjectIds(@Param("projectIds")List<Long> projectIds);

    void logicDeleteProductById(@Param("id")Long id);

    void deleteProductProjectMapByProductId(@Param("id")Long ProductId);

    void insertProductProjectMap(@Param("projectIds")List<Long> projectIds, @Param("productId")Long productId);

    Integer getProductNameCount(@Param("productName")String productName);

    void updateProduct(@Param("product")ProductVO product);

    Product getProductInfo(@Param("id")Long id);

    List<ProjectVO> getProjectListByProductId(@Param("productId")Long productId);

    List<Long> getProjectIdsByProductId(@Param("productId")Long productId);

    void deleteByProjectIdAndProductId(@Param("productId")Long productId, @Param("projectId")Long projectId);

    List<ProductVO> getProductList(@Param("advertiserName")String advertiserName, @Param("productName")String productName);

    List<SaleVO> getSalesListByProductId(@Param("productId")Long productId);

    List<UserDto> getYunyingListByProductId(@Param("productId")Long productId);

}
