package cn.com.ctop.common.module.service;

import cn.com.ctop.common.module.entity.Advertiser;
import cn.com.ctop.common.module.entity.Product;
import cn.com.ctop.common.module.entity.Project;
import cn.com.ctop.common.module.vo.ProductVO;
import cn.com.ctop.common.module.vo.ProjectVO;
import com.baomidou.mybatisplus.extension.service.IService;
import com.github.pagehelper.PageInfo;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 项目
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-11-19
 */
public interface IProductService extends IService<Product> {

    List<Advertiser> advertiserList();

    List<Project> getProjectListByAdvertiserId(String advertiserId);

    Map<String,Object> getSaleAndYunyingListByProjectIds(List<Long> projectIds);

    void deleteProduct(Long id);

    void insertOrUpdateProduct(ProductVO product);

    Integer getProductNameCount(String productName);

    void insertProductProjectMap(Long productId, List<Long> projectIds);

    Map<String, Object> getProductInfo(Long productId);

    void deleteByProjectIdAndProductId(Long projectId, Long productId);

    List<ProjectVO> getProjectListByProductId(Long productId);

    PageInfo<ProductVO> getProductList(String advertiserName, String productName, Integer pageNum, Integer pageSize);

    List<Long> getProjectIdsByProductId(Long productId);

}
