package cn.com.ctop.crawler.modules.taobao.service.impl;

import cn.com.ctop.common.module.utils.HttpUtils;
import cn.com.ctop.crawler.modules.taobao.service.TaobaoJhsbybtService;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.commons.codec.digest.DigestUtils;
import org.apache.http.cookie.Cookie;
import org.springframework.stereotype.Service;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.math.BigDecimal;
import java.util.*;

@Service
public class TaobaoJhsbybtServiceImpl implements TaobaoJhsbybtService {

    public String getGoodsList(int page){
        String url = "https://h5api.m.taobao.com/h5/mtop.tmall.kangaroo.core.service.route.aldlampservicefixedres/1.0/";
        Map<String,Object> paramMap = new HashMap<String,Object>();
        paramMap.put("jsv","2.5.1");
        paramMap.put("appKey","12574478");
        paramMap.put("t",new Date().getTime());
        paramMap.put("sign","56b679fe3a6de0cd4ffa8ccb8680ff83");
        paramMap.put("timeout",3000);
        paramMap.put("api","mtop.tmall.kangaroo.core.service.route.AldLampServiceFixedRes");
        paramMap.put("params","[object Object]");
        paramMap.put("dataType","jsonp");
        paramMap.put("v","1.0");
        paramMap.put("preventFallback",true);
        paramMap.put("type","jsonp");
        paramMap.put("callback","mtopjsonp2");
        paramMap.put("data","{\"curPageUrl\":\"https%3A%2F%2Fmarket.m.taobao.com%2Fapp%2Ftmall-def%2Fjhsbybt%2Fweb%2Findex.html%3FdisableNav%3DYES%26itemIds%3D617136337387%26spm%3D608.14027681%2F8.bubbles.d0\",\"resId\":\"8613423\",\"pageSize\":20,\"params\":\"{\\\"backupParams\\\":\\\"frontCatId,page\\\",\\\"bizId\\\":\\\"2022\\\",\\\"resId\\\":\\\"8613423\\\",\\\"pageSize\\\":20,\\\"frontCatId\\\":\\\"jingxuan\\\",\\\"page\\\":"+page+",\\\"query\\\":\\\"\\\",\\\"itemIds\\\":\\\"613480362477,570133944073,622530871392,617136337387\\\"}\",\"appId\":\"8613423\",\"backupParams\":\"\",\"pvuuid\":\"v1-93bed822-738b-4e5e-95df-ad2790b8662c-1596698955217\",\"__pvuuid\":\"v1-93bed822-738b-4e5e-95df-ad2790b8662c-1596698955217\",\"_pvuuid\":\"v1-93bed822-738b-4e5e-95df-ad2790b8662c-1596698955217\"}");
        Map<String,String> headerMap = new HashMap<String,String>();
        headerMap.put("Accept-Encoding","gzip, deflate, br");
        headerMap.put("Connection","keep-alive");
        headerMap.put("User-Agent","Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36");
        headerMap.put("Accept","*/*");
        headerMap.put("Content-Type","application/xml");
        headerMap.put("Referer","https://market.m.taobao.com/app/tmall-def/jhsbybt/web/index.html?disableNav=YES&itemIds=617136337387&spm=608.14027681/8.bubbles.d0");
        String result = HttpUtils.httpGet(url,paramMap,headerMap);
        List<Cookie> cookieList = HttpUtils.COOKIESTORE.getCookies();
        String token = "";
        String cookie = "";
        for (Cookie ck : cookieList){
            if(ck.getName().equals("_m_h5_tk")){
                token = ck.getValue().split("_")[0];
            }
            cookie = cookie + ck.getName()+"="+ck.getValue()+";";
        }
        String sign = DigestUtils.md5Hex(token+"&"+paramMap.get("t")+"&"+paramMap.get("appKey")+"&"+paramMap.get("data"));
        paramMap.put("sign",sign);
        headerMap.put("Cookie",cookie);
        result = HttpUtils.httpGet(url,paramMap,headerMap);
        return result;
    }

    public static void main(String[] args){
        try {
            PrintStream out = new PrintStream("D:/bybt0901.csv");
            System.setOut(out);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        System.out.println("商品id,商品名,销量,商品logo,设计图,商品图,商品链接,正常价,,,补贴价,补贴券");
        TaobaoJhsbybtServiceImpl tb = new TaobaoJhsbybtServiceImpl();
        int i = 1;
        Boolean hasMore = true;
        while (hasMore){
            try {
                String result = tb.getGoodsList(i);
                result = result.replace("mtopjsonp2(","");
                result = result.substring(0,result.length()-1);
                ObjectMapper mapper = new ObjectMapper();
                JsonNode rootNode = mapper.readTree(result);
                Boolean success = rootNode.get("data").get("resultValue").get("8613423").get("success").asBoolean();
                while (!success){
                    Thread.sleep(3000L);
                    result = tb.getGoodsList(i);
                    result = result.replace("mtopjsonp2(","");
                    result = result.substring(0,result.length()-1);
                    mapper = new ObjectMapper();
                    rootNode = mapper.readTree(result);
                    success = rootNode.get("data").get("resultValue").get("8613423").get("success").asBoolean();
                }
                hasMore = rootNode.get("data").get("resultValue").get("8613423").get("data").get("hasMore").asBoolean();
                Iterator<JsonNode> items = rootNode.get("data").get("resultValue").get("8613423").get("data").get("items").iterator();
                while (items.hasNext()){
                    JsonNode itemNode = items.next();
                    String cjmsItemName = itemNode.get("cjmsItemName").asText();
                    String itemSoldInfo = itemNode.get("itemSoldInfo").asText();
                    String picUrl = itemNode.get("picUrl").asText();
                    String cjmsTaobaoEntrance = itemNode.get("cjmsTaobaoEntrance").asText();
                    String couponAmount = itemNode.get("couponAmount").asText();
                    String orgPrice = itemNode.get("orgPrice").asText();
                    String brandLogo = itemNode.get("brandLogo").asText();
                    String couponPrice = itemNode.get("couponPrice").asText();
                    String actPrice = itemNode.get("actPrice").asText();
                    String cutPrice = itemNode.get("cutPrice").asText();
                    String itemUrl = itemNode.get("itemUrl").asText();
                    String itemId = itemNode.get("itemId").asText();
                    System.out.println(itemId+","+cjmsItemName+","+
                                    itemSoldInfo+","+
                            brandLogo+","+
                            picUrl+","+
                            cjmsTaobaoEntrance+","+
                            itemUrl+","+
                            actPrice+","+
                            cutPrice+","+
                            orgPrice+","+
                            couponPrice+","+
                            couponAmount);
                }
                i++;
                Thread.sleep(3000L);
            }catch (Exception e){
                e.printStackTrace();
            }
        }

    }
}
